
IF EXISTS(SELECT * FROM sys.server_event_sessions WHERE 
name='RecompileAudit')
   DROP EVENT SESSION [RecompileAudit] ON SERVER;
CREATE EVENT SESSION [RecompileAudit]
ON SERVER
ADD EVENT sqlserver.sp_statement_starting(
    ACTION (sqlserver.sql_text)
    WHERE (([state]=(1)))),
ADD EVENT sqlserver.sql_statement_starting(
    ACTION (sqlserver.sql_text)
    WHERE (([state]=(1))))
ADD TARGET package0.ring_buffer
WITH (MAX_MEMORY = 4096KB, EVENT_RETENTION_MODE = ALLOW_SINGLE_EVENT_LOSS, 
MAX_DISPATCH_LATENCY = 3000 SECONDS, MAX_EVENT_SIZE = 0KB, 
MEMORY_PARTITION_MODE = NONE, TRACK_CAUSALITY = OFF, STARTUP_STATE = OFF)

--To test it I just created a statement that interleaves DDL and DML:

declare @SQL    varchar(1000) = '',
 @runtime datetime = getdate(),
 @Lognumber smallint = 0

if object_id('tempdb..#errors') is not null
begin
  drop table #errors
end

create table #errors
(
rowid int identity primary key,
entrytime datetime,
source varchar(50),
logentry varchar(4000),
emailtext varchar(3000)
)

select @SQL = 'exec master..xp_readerrorlog ' + 
convert(varchar(3),@lognumber)
insert into #errors (entrytime, source, logentry)
execute (@SQL)

delete #errors
where entrytime is null
or entrytime <  dateadd(mi, -5, @runtime)

select *
from #errors

/*
What is interesting is for a single execution you get multiple recompiles 
logged which makes sense because it should recompile every time it changes 
from DML to DDL and back.  I don't like that I have to carry an action on 
the event which is synchronously executed on the calling thread just to 
get the sql_text, I would think that this information would be available 
as a part of the starting event?
*/
