
-- 138
select * from sys.trace_xe_event_map
-- 22
select * from sys.trace_xe_action_map

-- correspond XEvent to trace event
-- 138 events
SELECT 
    t.trace_event_id, 
    t.name [event_class], 
    e.package_name, 
    e.xe_event_name 
FROM sys.trace_events t 
JOIN sys.trace_xe_event_map e 
    ON t.trace_event_id = e.trace_event_id
ORDER BY event_class

-- 182 rows affected? Only 180 trace events
SELECT DISTINCT
    t.trace_event_id, 
    t.name [event_class], 
    e.package_name, 
    e.xe_event_name 
FROM sys.trace_events t 
LEFT OUTER JOIN sys.trace_xe_event_map e 
    ON t.trace_event_id = e.trace_event_id
ORDER BY trace_event_id

-- 180 here, where are the dups?
-- Three XEvents mapped to 1 trace event - Performance statistics map to:
-- query_cache_removal_statistics, query_pre_execution_showplan, uncached_sql_batch_statistics
SELECT DISTINCT
    t.trace_event_id, 
    t.name [event_class] 
    --e.package_name, 
    --e.xe_event_name 
FROM sys.trace_events t 
LEFT OUTER JOIN sys.trace_xe_event_map e 
    ON t.trace_event_id = e.trace_event_id
ORDER BY trace_event_id

-- Left outer join: trace events not converted to XEvents
-- 44 missing XEvents are:
-- 41 Audit trace events - converted to XEvent auditing
-- Also 3 odd trace events: Mount Tape, Trace File Close, SQL:FullTextQuery
SELECT 
    t.trace_event_id, 
    t.name [event_class], 
    e.package_name, 
    e.xe_event_name 
FROM sys.trace_events t 
LEFT OUTER JOIN sys.trace_xe_event_map e 
    ON t.trace_event_id = e.trace_event_id
WHERE e.xe_event_name IS NULL
ORDER BY event_class


-- trace fields to actions
-- 22 of these
-- 66 rows in sys.trace_columns
SELECT 
    c.trace_column_id, 
    c.name [column_name], 
    a.package_name, 
    a.xe_action_name 
FROM sys.trace_columns c 
JOIN  sys.trace_xe_action_map a 
    ON c.trace_column_id = a.trace_column_id

-- all trace event fields to actions for all XEvents
USE master
GO
SELECT DISTINCT 
   tb.trace_event_id, 
   te.name AS 'Event Class', 
   em.package_name AS 'Package', 
   em.xe_event_name AS 'XEvent Name', 
   tb.trace_column_id, 
   tc.name AS 'SQL Trace Column', 
   am.xe_action_name as 'Extended Events action' 
FROM (sys.trace_events te LEFT OUTER JOIN dbo.trace_xe_event_map em 
   ON te.trace_event_id = em.trace_event_id) LEFT OUTER JOIN sys.trace_event_bindings tb 
   ON em.trace_event_id = tb.trace_event_id LEFT OUTER JOIN sys.trace_columns tc 
   ON tb.trace_column_id = tc.trace_column_id LEFT OUTER JOIN dbo.trace_xe_action_map am 
   ON tc.trace_column_id = am.trace_column_id 
ORDER BY te.name, tc.name

-- mapping for trace id 1
USE MASTER; 
GO 
DECLARE @trace_id int 
SET @trace_id = 1 
SELECT DISTINCT el.eventid, em.package_name, em.xe_event_name AS 'event' 
   , el.columnid, ec.xe_action_name AS 'action' 
FROM (sys.fn_trace_geteventinfo(@trace_id) AS el 
   LEFT OUTER JOIN dbo.trace_xe_event_map AS em 
      ON el.eventid = em.trace_event_id) 
LEFT OUTER JOIN dbo.trace_xe_action_map AS ec 
   ON el.columnid = ec.trace_column_id 
WHERE em.xe_event_name IS NOT NULL AND ec.xe_action_name IS NOT NULL
GO


